/*!=============================================================================
  ==============================================================================

  \file    udp_interface.h

  \author  Stefan Schaal
  \date    Feb 2016

  ==============================================================================
  \remarks
  
  header file for udp_interfapce.cpp
  
  ============================================================================*/
  
#ifndef _udp_interface_
#define _udp_interface_

// the NAO sensor definitions
enum SensorType { HEAD_PITCH,
		  HEAD_YAW,
		  L_ANKLE_PITCH,
		  L_ANKLE_ROLL,
		  L_ELBOW_ROLL,
		  L_ELBOW_YAW,
		  L_NHAND,
		  L_HIP_PITCH,
		  L_HIP_ROLL,
		  L_HIP_YAW_PITCH,
		  L_KNEE_PITCH,
		  L_SHOULDER_PITCH,
		  L_SHOULDER_ROLL,
		  L_WRIST_YAW,
		  R_ANKLE_PITCH,
		  R_ANKLE_ROLL,
		  R_ELBOW_ROLL,
		  R_ELBOW_YAW,
		  R_NHAND,
		  R_HIP_PITCH,
		  R_HIP_ROLL,
		  R_KNEE_PITCH,
		  R_SHOULDER_PITCH,
		  R_SHOULDER_ROLL,
		  R_WRIST_YAW,
		  ACC_X,
		  ACC_Y,
		  ACC_Z,
		  GYR_X,
		  GYR_Y,
		  ANGLE_X,
		  ANGLE_Y,
		  L_COP_X,
		  L_COP_Y,
		  L_TOTAL_WEIGHT,
		  R_COP_X,
		  R_COP_Y,
		  R_TOTAL_WEIGHT,
		  L_SONAR,
		  R_SONAR};

// communication buffer lengths
#define FBUFLEN_IN   (R_SONAR+1+1) // add 1 for zero element, and 1 for frame counter
#define CBUFLEN_IN   (FBUFLEN_IN*sizeof(float))    
#define FBUFLEN_OUT  ((R_WRIST_YAW+1)*2+1)   // add 1 for zero element, and 1 for frame counter
#define CBUFLEN_OUT  (FBUFLEN_OUT*sizeof(float))

#ifdef __cplusplus
extern "C" {
#endif

// function prototypes
int
init_udp_interface(void);

int
read_udp_interface(float *fbuf, int *err);

int
write_udp_interface(float *fbuf);

// external variables

#ifdef __cplusplus
}
#endif


#endif  /* _udp_interface_ */
