clear all;

vis = 0.2;

linksInfo = getLinkInfo_realRobot;


nbDofs = length(linksInfo);

for i = 1:nbDofs
  
  link{i} = computeLinkInfo(linksInfo{i}.name, linksInfo{i}.mass, ...
                            linksInfo{i}.com, linksInfo{i}.Iprinc, linksInfo{i}.Iaxes, linksInfo{i}.rotation, vis);
  
end


fid = fopen('LinkParameters.cf', 'w');

fprintf(fid,'/* this file contains the specification for the dynamic parameters of all links */ \n\n');
fprintf(fid,'/* format: keyword, mass, cmx, cmy, cmz, i11, i12, i13, i22, i23, i33, vis */\n\n');
fprintf(fid,'/* CAD parameters from NAO docs generated by computeLinks_realRobot.m  */\n\n\n');

for i = 1:nbDofs
  
  if(strcmp(link{i}.name, 'L_SFE') || strcmp(link{i}.name, 'R_SFE') ...
     ||strcmp(link{i}.name, 'L_HFE') || strcmp(link{i}.name, 'R_HFE') || ...
     strcmp(link{i}.name, 'B_TR') || strcmp(link{i}.name, 'B_HN') || strcmp(link{i}.name, 'R_EP'))
    fprintf(fid, '\n');
  end
  
  fprintf(fid, '%s\t', link{i}.name);
  fprintf(fid, '%f\t', link{i}.m);
  fprintf(fid, '%f\t', link{i}.mcm);
  fprintf(fid, '%f\t', link{i}.I);
  fprintf(fid, '%f\n', link{i}.vis);
  
end
fclose(fid);