/*!=============================================================================
  ==============================================================================

  \file    SL_user_motor.c

  \author  Stefan Schaal
  \date    Nov. 2009

  ==============================================================================
  \remarks
  
  Allows user specific motor servo initializations
  
  ============================================================================*/
  
// SL general includes of system headers
#include "SL_system_headers.h"

/* user specific headers */
#include "SL.h"
#include "SL_motor_servo.h"
#include "SL_shared_memory.h"

#include "SL_user.h"
#include "SL_man.h"

/* global variables */

/* local variables */

/* local functions */

/* external functions */


/*!*****************************************************************************
 *******************************************************************************
 \note  init_user_motor
 \date  July 1998
 
 \remarks 
 
 initializes user specific motor functionality
 
 *******************************************************************************
 Function Parameters: [in]=input,[out]=output

 none 

 ******************************************************************************/
int
init_user_motor(void)
{

  if (real_robot_flag) {
    // on the real robot, we use UDP packets as clock from a blocking
    // socket, and thus need the semaphore to be given all the time
    if (semGive(sm_motor_servo_sem) == ERROR)
    exit(-1);
  }

  
  return TRUE;
}
